apiVersion: v1
kind: Pod
metadata:
  annotations:
    scheduler.alpha.kubernetes.io/critical-pod: ""
  labels:
    component: kube-controller-manager
    tier: control-plane
  name: kube-controller-manager
  namespace: kube-system
spec:
  hostNetwork: true
  priorityClassName: system-cluster-critical
  containers:
  - name: kube-controller-manager
    image: registry.cn-hangzhou.aliyuncs.com/google_containers/kube-controller-manager-amd64:v{{ kube_version }}
    command:
      - kube-controller-manager
      - --v={{ log_level }}
      - --logtostderr=true
      - --address=127.0.0.1
      - --root-ca-file={{ ca }}
      - --cluster-signing-cert-file={{ ca }}
      - --cluster-signing-key-file={{ ca_key }}
      - --service-account-private-key-file={{ sa_private_key }}
      - --kubeconfig={{ controller_manager_kubeconfig }}
      - --leader-elect=true
      - --use-service-account-credentials=true
      - --node-monitor-grace-period=40s
      - --node-monitor-period=5s
      - --pod-eviction-timeout=2m0s
      - --controllers=*,bootstrapsigner,tokencleaner
      - --allocate-node-cidrs=true
      - --cluster-cidr={{ pod_network_cidr }}
      {% if feature_gates != '' -%}
      - --feature-gates={{ feature_gates }}
      {% endif -%}
      - --node-cidr-mask-size=24
    livenessProbe:
      failureThreshold: 8
      httpGet:
        host: 127.0.0.1
        path: /healthz
        port: 10252
        scheme: HTTP
      initialDelaySeconds: 15
      timeoutSeconds: 15
    resources:
      requests:
        cpu: 200m
    volumeMounts:
    - mountPath: {{ pki_dir }}
      name: k8s-certs
      readOnly: true
    - mountPath: /etc/ssl/certs
      name: ca-certs
      readOnly: true
    - mountPath: {{ controller_manager_kubeconfig }}
      name: kubeconfig
      readOnly: true
    - mountPath: /usr/libexec/kubernetes/kubelet-plugins/volume/exec
      name: flexvolume-dir
  volumes:
  - hostPath:
      path: {{ pki_dir }}
      type: DirectoryOrCreate
    name: k8s-certs
  - hostPath:
      path: /etc/ssl/certs
      type: DirectoryOrCreate
    name: ca-certs
  - hostPath:
      path: {{ controller_manager_kubeconfig }}
      type: File
    name: kubeconfig
  - hostPath:
      path: /usr/libexec/kubernetes/kubelet-plugins/volume/exec
      type: DirectoryOrCreate
    name: flexvolume-dir
